/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2011 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#include <cstring>
#include <algorithm>
#include <iostream>
#include <iterator>
#include "toppers/io.hpp"
#include "toppers/cpp.hpp"
#include "toppers/global.hpp"
#include "toppers/diagnostics.hpp"
#include "toppers/misc.hpp"
#include "toppers/itronx/preprocess.hpp"
#include <boost/spirit/include/classic.hpp>

namespace toppers
{
  namespace itronx
  {

    /*!
     *  \brief  ŪAPI `INCLUDE'Ÿ
     *  \param[in]  in      ϥե
     *  \param[out] out     ϥե
     *  \param[in]  codeset ʸ
     *  \param[out] dependencies  ¸طγǼNULLξϳǼʤ
     *  \param[out] onces   #pragma onceҤƤե̾γǼNULLξϳǼʤ
     *
     *  `INCLUDE' ΰϡITRON ͤΤΤȤϰۤʤꡢŰǰϤޤ #include 
     *  ƱѤ롣
     */
    void expand_include( text const& in, text& out, codeset_t codeset, std::set< std::string >* dependencies, std::set< std::string >* onces )
    {
      typedef text::container::const_iterator const_row_iterator;
      typedef std::string::size_type size_type;
      size_type const npos = std::string::npos;
      const_row_iterator first( in.begin().get_row() ), last( in.end().get_row() );

      out.set_line( first->line.file, first->line.line );
      for ( const_row_iterator iter( first ); iter != last; ++iter )
      {
        std::string const& buf = iter->buf;
        char state = 0;

        for ( size_type i = 0, n = buf.size(); i != n; ++i )
        {
          char c = buf[i];
          if ( c == '\'' || c == '\"' )
          {
            if ( state == 0 )
            {
              state = c;    // ʸ˥ƥ볫
            }
            else if ( buf[i - 1] != '\\' ) //  \' ޤ \" ǤϤʤ
            {
              state = 0;    // ʸ˥ƥ뽪λ
            }
            else if ( ( codeset == shift_jis ) && ( i >= 2 ) && is_lead< shift_jis >( buf[i - 2] ) )
            {
              state = 0;
            }
            out.push_back( c );
          }
          else if ( state != 0 )  // ʸ˥ƥ
          {
            out.push_back( c );
          }
          else
          {
            using namespace boost::spirit::classic;
            std::string headername;
            if ( iter == last )
            {
              return;
            }
            text::const_iterator iter2( iter, i );
            if ( iter2 == in.end() )
            {
              break;
            }
            parse_info< text::const_iterator > info
              = parse( iter2, in.end(),
                        ( str_p( "INCLUDE" ) >> *space_p
                          >> '(' >> *space_p
                            >> '\"' >> ( +( anychar_p - '\"' ) )[ assign( headername ) ] >> '\"' >> *space_p
                          >> ')' >> *space_p >> ';' ) );  // ֹ椬ΤǡåץѡϻѤʤ
            if ( info.hit )
            {
              std::vector< std::string > include_paths = get_global< std::vector< std::string > >( "include-path" );
              std::string hname = search_include_file( include_paths.begin(), include_paths.end(), headername );
              if ( hname.empty() )  // إå̾Ĥʤ
              {
                fatal( iter->line, _( "cannot open file `%1%\'" ), headername );
              }
              else if ( onces == 0 || onces->find( hname ) == onces->end() )
              {
                if ( dependencies != 0 )
                {
                  dependencies->insert( dir_delimiter_to_slash( hname ) );
                }
                out.push_back( ' ' ); // ߡƤʤȹֹ椬
                preprocess( hname, out, codeset, dependencies, onces );  // إå̾ǻꤵ줿եФƵŪ˹Ԥ
                iter = info.stop.get_row();
                i = info.stop.get_col() - 1;
                if ( iter != last )
                {
                  out.set_line( iter->line.file, iter->line.line );
                }
              }
            }
            else
            {
              if ( iter2.get_col() == 0 )
              {
                info = parse( iter2, in.end(),
                              ( *( space_p - eol_p ) >>
                                  ch_p( '#' ) >> *( space_p - eol_p ) >> "pragma" >> *( space_p - eol_p )
                                    >> "once"
                                    >> *( space_p - eol_p ) >> eol_p ) );
                if ( info.hit )
                {
                  if ( onces != 0 )
                  {
                    onces->insert( iter2.line().file );
                  }
                  out.push_back( '\n' );
                  iter = info.stop.get_row();
                  --iter;   // 󥯥ȤΤǤä᤹
                  break;
                }
              }
              if ( parse( iter2, in.end(),
                        ( str_p( "INCLUDE" ) >> *space_p >> '(' >> +( anychar_p - ')' ) >> ')' >> *space_p >> ';' ) ).hit )
              {
                warning( iter->line, _( "probably, %1% argument of `%2%\' is illegal" ), _( "1st" ), "INCLUDE" );
              }
              out.push_back( c );
            }
          }
        }
      }
    }

    /*!
     *  \brief  ե졼ե
     *  \param[in]  file    ե졼ե̾
     *  \param[out] result  
     *  \param[in]  codeset ʸ
     *  \param[out] dependencies  ¸طγǼNULLξϳǼʤ
     *  \param[out] onces   #pragma onceҤƤե̾γǼNULLξϳǼʤ
     */
    void preprocess( std::string const& file, text& result, codeset_t codeset, std::set< std::string >* dependencies, std::set< std::string >* onces )
    {
      std::string buf;
      read( file, buf );
      if ( buf.empty() )
      {
        return;
      }
      text txt;
      txt.set_line( file, 1 );
      remove_comment( buf.begin(), buf.end(), std::back_inserter( txt ), codeset );
      expand_include( txt, result, codeset, dependencies, onces );
    }

  }
}
